""" Test2 for Box2D """

import pygame
from pygame.locals import *
from pygame.color import *

from elements import *

def main():
    # PyGame Init
    pygame.init()
    screen = pygame.display.set_mode((800, 800))
    clock = pygame.time.Clock()

    # Create the Physical Space Class
    world = elements()
    
    # Add A Ground
    world.add_ground()
    world.add_wall((00, 00), (10, 800))
    world.add_wall((800, 00), (810, 800))

    # Default Settings
    running = True
    show = True
    
    # Main Loop
    while running:
        for event in pygame.event.get():
            if event.type == QUIT or (event.type == KEYDOWN and event.key == K_ESCAPE):
                # Bye Bye
                running = False
                
            elif event.type == KEYDOWN and event.key == K_SPACE:    
                # Pause with SPACE
                world.run_physics = not world.run_physics

            elif event.type == MOUSEBUTTONDOWN and event.button == 1:
                # Add Ball
                world.add_ball(event.pos)
                
            elif event.type == MOUSEBUTTONDOWN and event.button == 3:
                # Add Square
                world.add_rect(event.pos)

            elif event.type == KEYDOWN:
                if event.unicode == "1":
                    # Add many Balls
                    x, y = pygame.mouse.get_pos()
                    for i in range(5):
                        for j in range(5): world.add_ball((x-i,y-j))

                if event.unicode == "s":
                    show = not show
            
        # Clear Display

        # Update & Draw World
        world.update(40.0, 5)
        if show:
            screen.fill((255,255,255))
            world.draw(screen)
            pygame.display.flip()
        
        # Try to stay at 50 FPS
        clock.tick(40)
        
        # output framerate in caption
        pygame.display.set_caption("elements: %i | fps: %i" % (world.element_count, int(clock.get_fps())))

if __name__ == "__main__":
    main()
